$| = 1;

use Win32;
require 5.006;
use Win32API::CommPort qw( :PARAM :STAT 0.20);
use Time::HiRes qw( usleep gettimeofday tv_interval stat );

$com = new Win32API::CommPort ('COM7')||die "can't open COM4\n";

@required = qw (BAUD DATA STOP);

$com->is_databits(8);
$com->is_stopbits(1);
$com->is_baudrate(2400);

$faults = $com->initialize(@required);
if ($faults) {die "reqried paramaters not set before initialise\n"}

$rlsd = $com->MS_RLSD_ON."\n"; $binrlsd = unpack ("B8", (pack "C", $rlsd)); print "RLSD $binrlsd $rlsd\n";
$ring = $com->MS_RING_ON."\n"; $binring = unpack ("B8", (pack "C", $ring)); print "RING $binring $ring\n";
$dsr = $com->MS_DSR_ON."\n";$bindsr = unpack ("B8", (pack "C", $dsr)); print "DSR  $bindsr $dsr\n";
$cts = $com->MS_CTS_ON."\n";$bincts = unpack ("B8", (pack "C", $cts)); print "CTS  $bincts $cts\n";

# timer contstant;
$baud = 110;
$sleeptime = int (1000000/$baud);


# some char constants;
$fiftyfive = pack('c',0x55);
$ayay = pack('c',0xAA);
$zer = pack ('c', 0);

# serial constants;
$startbits = "";
$firstbit = "lsb";
$paritymode = "none";
$stopbits = "";




#1,000,000 microseconds in a second. need to wait 9091 uS before we send another bit.
#initialise
($startsec, $startms) = gettimeofday; $start = ($startsec*1000000)+$startms;

$bitssent =0;
$checksecs = 0;

#generate bits to send


for(;;)
{
for ($trychecksum=0; $trychecksum<256; $trychecksum++)

{
print "\nchecksum $trychecksum";

	$sendchrs = $fiftyfive.$ayay.pack('c', 0x45).$zer.pack('c', $trychecksum);

#	print "\n\nsending $sendchrs\n";
	
	@sendchars = split(//,$sendchrs);

	foreach $sendchar (@sendchars)
	{
#		print "$sendchar";

		$binchar = unpack("B8",$sendchar);
		print " $binchar";

		if ($firstbit eq "lsb")
		{
			$binchar = reverse $binchar;
		}
		print " $binchar";

		if ($paritymode ne "none")
		{
			$parityresult=0;
			
			@bitsforparity = split (//, $binchar);
			foreach $bitforparity (@bitsforparity)
			{
				if ($bitforparity == 1)
				{
					$parityresult++;
					if ($parityresult == 2){$parityresult = 0}
				}
			}

			#update for even parity
			if ($paritymode eq "even")
			{
				$parityresult++;
				if ($parityresult == 2){$parityresult = 0}
			}
	
			print "($parityresult) ";

		}
		else
		{
			$parityresult = "";
			print "(off) ";
		}

		$bintosend = $startbits.$binchar.$parityresult.$stopbits;

		print "sending $bintosend\n";
		
		# this hammers processor, but is more accurate! :(
		for ($binpos=0;$binpos<=(length($bintosend));$binpos++)
		{
			$state = substr $bintosend, $binpos, 1;

			# change to desired state
			do
			{
				($endsec, $endms) = gettimeofday; $end = ($endsec*1000000)+$endms;	
				$waited = $end-$start;
			} 
			until ($waited > ($sleeptime-1));

			#$com->dtr_active($state);
		        $com->rts_active($state);
			
			print $state;

			$bitssent++;
			if ($checksecs != $endsec)
			{
				print "\n------------------------------------ 1 second passes - bits sent $bitssent\n";
				$checksecs = $endsec;
				$bitssent=0;
			}

			$taken = $end-$realstart;	
			
			# this is a debug
			#print "\t$end. Wait\t$waited \ttook\t $taken\n";

			$start = $start+$sleeptime;
			$realstart = $end;

			if (($start+$sleeptime) < $end)
			{
				print "**** LOST TIMING! ****";
			}
		}
		print "\n";
	}
}
}





#for(;;){
#$modemstatus = $com->is_modemlines;
#	if ($modemstatus ne $oldmodemstatus)
#	{
#
#
#		$binmod = unpack ("B8", (pack "C", $modemstatus));
#
#		print "$binmod ";
#
#		$rlsd = substr ($binmod,0,1); if ($rlsd == 0) {print "---- "} else {print "rlsd "}	
#		$ring = substr ($binmod,1,1); if ($ring == 0) {print "---- "} else {print "ring "}
#		$dsr = substr ($binmod,2,1);  if ($dsr == 0) {print "--- "} else {print "dsr "}
#		$cts = substr ($binmod,3,1); if ($cts == 0) {print "--- "} else {print "cts "}
#
#
#		print "$modemstatus ";
#
#		if ($modemstatus == 0){print "Overlay";}
#		if ($modemstatus == 16){print "Computer only";}
#		if ($modemstatus == 176){print "External only";}
#
#		print "\n";
#
#		$oldmodemstatus=$modemstatus
#	}
#}
